
-- ESA_Matador.
-- SMART Artillery IA
-- TO make it work, you just need to load last version of Mist and then this file ("artillery 1.02 English.lua"). 
-- In mission editor, you will put a group called "observername" (or whatever you want) and an artillery group called "artilleryname" (or whatever you want)
-- After that, "do script" and call the function "artilleryIA("observername", "artilleryname")" 

rangodeteccionobs = 15000 	-- detection range for observer... this is not the artillery firing range!!!
probability_level = 60 		-- If there are some units in range, the probability to fire at them is that % 
tiempominimo = 100 		-- minimum time for every check (it is random between min and max). Take into account that the artillery group takes extra time before shooting... this is not accounted.
tiempomaximo = 200 		-- minimum time for every check (it is random between min and max). Take into account that the artillery group takes extra time before shooting... this is not accounted.
radiodebombardeo = 200		-- radius for bombing
cantidaddedisparos = 24 	-- ammount of rounds shot to the enemy. Then it stops and restart checking for enemies.

activarmensajeunderfire = true

	function table_count(tt, item) -- To count doubles in a table
	  local count
	  count = 0
	  for ii,xx in pairs(tt) do
		if item == xx then count = count + 1 end
	  end
	  return count
	end

	function table_unique(tt)-- to remove remove doubles in a table
				local newtable
				newtable = {}
				for ii,xx in ipairs(tt) do
				if(table_count(newtable, xx) == 0) then
				newtable[#newtable+1] = xx
				end
				end
				return newtable
				end
	

 
function observers(observerunit, artgroup)   
-- trigger.action.outText("evaluando",20)
	if (observerunit~=nil) and (artgroup~=nil) then
	 _observer = Group.getByName(observerunit)
	 
		if _observer:getCoalition() == 1 then
		local blueunits = mist.makeUnitTable({'[blue][vehicle]'})
		local redunits = mist.makeUnitTable({tostring('[g]'..observerunit)})       
		LOSData = mist.getUnitsLOS(redunits,2,blueunits,2,rangodeteccionobs)
	 
		elseif
		_observer:getCoalition() == 2 then
		local redunits = mist.makeUnitTable({'[red][vehicle]'})
		local blueunits = mist.makeUnitTable({tostring('[g]'..observerunit)})       
		LOSData = mist.getUnitsLOS(blueunits,2,redunits,2,rangodeteccionobs)
		end	
		
			if #LOSData > 0 then		
				local artytargets = {}
					for k, v in pairs (LOSData) do
						local tabledata = LOSData[k]
						for j, w in pairs (tabledata.vis)do            
							local targetinLOS = tabledata.vis[j]
							artytargets[#artytargets+1] = targetinLOS
						end
					end
					
				local artytargetsonly = table_unique(artytargets)
				local randomunit = math.random(#artytargetsonly)
				local _unitarget = artytargets[randomunit]:getName()
						-- trigger.action.outText(_unitarget,20)
						-- trigger.action.outText(artytargets,20)
				artbomb(_unitarget,artgroup)
				
				local LOSData = {}
				local artytargetsonly = {}
			
			end
	end
end
 


function artbomb(arttarget,artgr)  
probabilityoffiring = math.random(0,100)
-- trigger.action.outText(probabilityoffiring, 30)
	if probability_level > probabilityoffiring then
			local artygroup = Group.getByName(artgr):getID()  
			local artygroupname = Group.getByName(artgr):getName()  
			local targetunit = Unit.getByName(arttarget)		
			local targetname = targetunit:getName()
			local targetartgroupname = targetunit:getGroup():getName()

			local targetpoint = targetunit:getPosition().p
			local task1 ={ 	id = 'FireAtPoint', 
							params = { 
									point = { y = targetpoint.z, x = targetpoint.x, zoneRadius =100},
									radius = radiodebombardeo, 
									expendQty = cantidaddedisparos,
									expendQtyEnabled = true, 
									weaponType = number, 
									}
						 } 
	 
					_group = Group.getByName(artgr)
					_controller = _group:getController()
					_controller:pushTask(task1)
			if activarmensajeunderfire == true then
					mist.scheduleFunction(trigger.action.outTextForCoalition, {targetunit:getCoalition(),"Attention all aircraft: "..targetartgroupname.." friendly artillery fire ops within 15NM of waypoint SNAPSHOT below 7000 feet ", 30}, timer.getTime()+ math.random(tiempominimo,tiempomaximo))
			else
			end
	end
end               


function artilleryIA(obs, bat) 
mist.scheduleFunction(observers, {obs,bat}, timer.getTime()+ math.random(tiempominimo,tiempomaximo),200)

end





-- artilleryIA("JTAC1", "BLUEFOR ARTY")
-- artilleryIA("obs2", "art2")


















